//
//  LibraryModel.swift
//  DocHub
//
//  Created by Tristan Juricek on 6/10/14.
//  Copyright (c) 2014 Perforce. All rights reserved.
//

import Foundation

// A DocHub library is an abstraction over connections to remote versioning 
// repositories.
//
// DocHub isn't really concerned about branching. Thus, a Library could be 
// thought of as "go to this branch out on that versioning server".
@objc protocol Library {
    
    var name: String { get }
    
    // Each library has a single collection of areas, that should maintain a
    // strict order
    var areas: Area[] { get }
}

func == (lhs: Library, rhs: Library) -> Bool {
    return lhs.name == rhs.name
}